#!/usr/bin/perl -w

# Copyright (C) 2000 - 2001, GCR. Distributed under GNU GPL.

$cmd="mysql -vvv -u root -p";
$username="guillem";
$database="monitor";

$url4oui="http://standards.ieee.org/regauth/oui/oui.txt";
$downcmd="wget $url4oui";
$ouifile="oui.txt";
$tabfile="oui.tab";

$url4serv="http://www.graffiti.com/services";
$downcmd2="wget $url4serv";
$servfile="services";
$tabfile2="services.tab";

%protonum=('tcp'=>6, 'udp'=>17);	# Millor una taula amb /etc/protocols a la BD?

if(! -e $ouifile) {
	system $downcmd;
}
open (OUI, "<$ouifile") || die "Cannot open $ouifile for input: $!";
open (TAB, ">$tabfile") || die "Cannot open $tabfile for output: $!";
while (<OUI>) {
	if ((s/\s+\(base 16\)\s+/\t/)&&(s/([0123456789ABCDEF]{6})/hex($1)/e)) {
		print TAB;
	}
}
close OUI;
close TAB;

if(! -e $servfile) {
	system $downcmd2;
}
open (SERV, "<$servfile") || die "Cannot open $servfile for input: $!";
open (TAB2, ">$tabfile2") || die "Cannot open $tabfile2 for output: $!";
while (<SERV>) {
	if (/\A[^#\s]/) {
		s/\A(\w+)\s+(\d+)\/(TcP|uDp)/printf(TAB2 "%s\t%u\t%s\n", $2, $protonum{lc($3)}, $1)/ei;
	}
}
close SERV;
close TAB2;

open (CMD, "|$cmd") || die "Cannot fork: $!";
print CMD <<_MYSQL_END_;
grant all on $database.* to $username\@localhost;
create database if not exists $database;
use $database;
create table if not exists oui (
	oui mediumint unsigned not null,
	org varchar(64) not null,
	primary key (oui)
);
load data local infile '$tabfile' into table oui;
create table if not exists host (
	ip integer unsigned not null,
	mach mediumint unsigned not null references oui(oui),
	macl mediumint unsigned not null,
	omega timestamp not null,
	alfa timestamp not null,
	primary key (ip, mach, macl)
);
create table if not exists servei (
	port smallint unsigned not null,
	protocol tinyint unsigned not null,
	nom varchar(16) not null,
	primary key (port, protocol)
);
load data local infile '$tabfile2' into table servei;
create table if not exists obert (
	ip integer unsigned not null references host(ip),
	mach mediumint unsigned not null references host(mach),
	macl mediumint unsigned not null references host(macl),
	port smallint unsigned not null references servei(port),
	protocol tinyint unsigned not null references servei(protocol),
	omega timestamp not null,
	alfa timestamp not null,
	primary key (ip, mach, macl, port, protocol)
);
_MYSQL_END_
close CMD;

unlink $tabfile;
unlink $tabfile2;
print "RECORDA: 'mysqladmin -u $username password nou_password'\n";

